<?php

namespace Neo\UserBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Uaddresses
 *
 * @ORM\Table(name="UAddresses")
 * @ORM\Entity
 * @ORM\Entity(repositoryClass="Neo\UserBundle\Entity\UaddressesRepository")
 * 
 */
class Uaddresses
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="streetNumber", type="string", length=10, nullable=true)
     */
    private $streetnumber;

    /**
     * @var string
     *
     * @ORM\Column(name="buildingName", type="string", length=45, nullable=true)
     */
    private $buildingname;

    /**
     * @var string
     *
     * @ORM\Column(name="streetSuffix", type="string", length=10, nullable=true)
     */
    private $streetsuffix;

    /**
     * @var string
     *
     * @ORM\Column(name="streetName", type="string", length=100, nullable=true)
     */
    private $streetname;

    /**
     * @var string
     *
     * @ORM\Column(name="streetType", type="string", length=100, nullable=true)
     */
    private $streettype;

    /**
     * @var string
     *
     * @ORM\Column(name="streetDirection", type="string", length=2, nullable=true)
     */
    private $streetdirection;

    /**
     * @var integer
     *
     * @ORM\Column(name="addressType_id", type="integer", nullable=true)
     */
    private $addresstypeId;

    /**
     * @var string
     *
     * @ORM\Column(name="addressTypeIdentifier", type="string", length=45, nullable=true)
     */
    private $addresstypeidentifier;

    /**
     * @var string
     *
     * @ORM\Column(name="localMunicipality", type="string", length=100, nullable=true)
     */
    private $localmunicipality;

    /**
     * @var string
     *
     * @ORM\Column(name="cityTown", type="string", length=100, nullable=true)
     */
    private $citytown;

    /**
     * @var string
     *
     * @ORM\Column(name="governingDistrict", type="string", length=100, nullable=true)
     */
    private $governingdistrict;

    /**
     * @var string
     *
     * @ORM\Column(name="postaArea", type="string", length=100, nullable=true)
     */
    private $postaarea;

    /**
     * @var float
     *
     * @ORM\Column(name="latitude", type="float", nullable=true)
     */
    private $latitude;

    /**
     * @var float
     *
     * @ORM\Column(name="longitude", type="float", nullable=true)
     */
    private $longitude;

    /**
     * @var \Ucountries
     *
     * @ORM\ManyToOne(targetEntity="Ucountries")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="country_id", referencedColumnName="id")
     * })
     */
    private $country;



    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set streetnumber
     *
     * @param string $streetnumber
     * @return Uaddresses
     */
    public function setStreetnumber($streetnumber)
    {
        $this->streetnumber = $streetnumber;
    
        return $this;
    }

    /**
     * Get streetnumber
     *
     * @return string 
     */
    public function getStreetnumber()
    {
        return $this->streetnumber;
    }

    /**
     * Set buildingname
     *
     * @param string $buildingname
     * @return Uaddresses
     */
    public function setBuildingname($buildingname)
    {
        $this->buildingname = $buildingname;
    
        return $this;
    }

    /**
     * Get buildingname
     *
     * @return string 
     */
    public function getBuildingname()
    {
        return $this->buildingname;
    }

    /**
     * Set streetsuffix
     *
     * @param string $streetsuffix
     * @return Uaddresses
     */
    public function setStreetsuffix($streetsuffix)
    {
        $this->streetsuffix = $streetsuffix;
    
        return $this;
    }

    /**
     * Get streetsuffix
     *
     * @return string 
     */
    public function getStreetsuffix()
    {
        return $this->streetsuffix;
    }

    /**
     * Set streetname
     *
     * @param string $streetname
     * @return Uaddresses
     */
    public function setStreetname($streetname)
    {
        $this->streetname = $streetname;
    
        return $this;
    }

    /**
     * Get streetname
     *
     * @return string 
     */
    public function getStreetname()
    {
        return $this->streetname;
    }

    /**
     * Set streettype
     *
     * @param string $streettype
     * @return Uaddresses
     */
    public function setStreettype($streettype)
    {
        $this->streettype = $streettype;
    
        return $this;
    }

    /**
     * Get streettype
     *
     * @return string 
     */
    public function getStreettype()
    {
        return $this->streettype;
    }

    /**
     * Set streetdirection
     *
     * @param string $streetdirection
     * @return Uaddresses
     */
    public function setStreetdirection($streetdirection)
    {
        $this->streetdirection = $streetdirection;
    
        return $this;
    }

    /**
     * Get streetdirection
     *
     * @return string 
     */
    public function getStreetdirection()
    {
        return $this->streetdirection;
    }

    /**
     * Set addresstypeId
     *
     * @param integer $addresstypeId
     * @return Uaddresses
     */
    public function setAddresstypeId($addresstypeId)
    {
        $this->addresstypeId = $addresstypeId;
    
        return $this;
    }

    /**
     * Get addresstypeId
     *
     * @return integer 
     */
    public function getAddresstypeId()
    {
        return $this->addresstypeId;
    }

    /**
     * Set addresstypeidentifier
     *
     * @param string $addresstypeidentifier
     * @return Uaddresses
     */
    public function setAddresstypeidentifier($addresstypeidentifier)
    {
        $this->addresstypeidentifier = $addresstypeidentifier;
    
        return $this;
    }

    /**
     * Get addresstypeidentifier
     *
     * @return string 
     */
    public function getAddresstypeidentifier()
    {
        return $this->addresstypeidentifier;
    }

    /**
     * Set localmunicipality
     *
     * @param string $localmunicipality
     * @return Uaddresses
     */
    public function setLocalmunicipality($localmunicipality)
    {
        $this->localmunicipality = $localmunicipality;
    
        return $this;
    }

    /**
     * Get localmunicipality
     *
     * @return string 
     */
    public function getLocalmunicipality()
    {
        return $this->localmunicipality;
    }

    /**
     * Set citytown
     *
     * @param string $citytown
     * @return Uaddresses
     */
    public function setCitytown($citytown)
    {
        $this->citytown = $citytown;
    
        return $this;
    }

    /**
     * Get citytown
     *
     * @return string 
     */
    public function getCitytown()
    {
        return $this->citytown;
    }

    /**
     * Set governingdistrict
     *
     * @param string $governingdistrict
     * @return Uaddresses
     */
    public function setGoverningdistrict($governingdistrict)
    {
        $this->governingdistrict = $governingdistrict;
    
        return $this;
    }

    /**
     * Get governingdistrict
     *
     * @return string 
     */
    public function getGoverningdistrict()
    {
        return $this->governingdistrict;
    }

    /**
     * Set postaarea
     *
     * @param string $postaarea
     * @return Uaddresses
     */
    public function setPostaarea($postaarea)
    {
        $this->postaarea = $postaarea;
    
        return $this;
    }

    /**
     * Get postaarea
     *
     * @return string 
     */
    public function getPostaarea()
    {
        return $this->postaarea;
    }

    /**
     * Set latitude
     *
     * @param float $latitude
     * @return Uaddresses
     */
    public function setLatitude($latitude)
    {
        $this->latitude = $latitude;
    
        return $this;
    }

    /**
     * Get latitude
     *
     * @return float 
     */
    public function getLatitude()
    {
        return $this->latitude;
    }

    /**
     * Set longitude
     *
     * @param float $longitude
     * @return Uaddresses
     */
    public function setLongitude($longitude)
    {
        $this->longitude = $longitude;
    
        return $this;
    }

    /**
     * Get longitude
     *
     * @return float 
     */
    public function getLongitude()
    {
        return $this->longitude;
    }

    /**
     * Set country
     *
     * @param \Neo\UserBundle\Entity\Ucountries $country
     * @return Uaddresses
     */
    public function setCountry(\Neo\UserBundle\Entity\Ucountries $country = null)
    {
        $this->country = $country;
    
        return $this;
    }

    /**
     * Get country
     *
     * @return \Neo\UserBundle\Entity\Ucountries 
     */
    public function getCountry()
    {
        return $this->country;
    }
     public function __tostring()
    {
        return $this->getStreetname();    
    }
}