<?php

namespace Neo\UserBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Uapps
 *
 * @ORM\Table(name="UApps")
 * @ORM\Entity
 */
class Uapps
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=100, nullable=false)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="version", type="string", length=45, nullable=false)
     */
    private $version;

    /**
     * @var integer
     *
     * @ORM\Column(name="priorVersion_id", type="integer", nullable=true)
     */
    private $priorversionId;

    /**
     * @var boolean
     *
     * @ORM\Column(name="active", type="boolean", nullable=true)
     */
    private $active;

    /**
     * @var integer
     *
     * @ORM\Column(name="developer_id", type="integer", nullable=false)
     */
    private $developerId;

    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @ORM\ManyToMany(targetEntity="Udevelopers", inversedBy="app")
     * @ORM\JoinTable(name="uappsdevelopers",
     *   joinColumns={
     *     @ORM\JoinColumn(name="app_id", referencedColumnName="id")
     *   },
     *   inverseJoinColumns={
     *     @ORM\JoinColumn(name="developer_id", referencedColumnName="id")
     *   }
     * )
     */
    private $developer;

    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @ORM\ManyToMany(targetEntity="Uenterprises", mappedBy="app")
     */
    private $enterprise;

    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @ORM\ManyToMany(targetEntity="Uprojects", mappedBy="app")
     */
    private $project;

    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @ORM\ManyToMany(targetEntity="User", mappedBy="app")
     */
    private $user;

    /**
     * @var \Uappsfeemodels
     *
     * @ORM\ManyToOne(targetEntity="Uappsfeemodels")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="feeModel_id", referencedColumnName="id")
     * })
     */
    private $feemodel;

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->developer = new \Doctrine\Common\Collections\ArrayCollection();
        $this->enterprise = new \Doctrine\Common\Collections\ArrayCollection();
        $this->project = new \Doctrine\Common\Collections\ArrayCollection();
        $this->user = new \Doctrine\Common\Collections\ArrayCollection();
    }
    

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return Uapps
     */
    public function setName($name)
    {
        $this->name = $name;
    
        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set version
     *
     * @param string $version
     * @return Uapps
     */
    public function setVersion($version)
    {
        $this->version = $version;
    
        return $this;
    }

    /**
     * Get version
     *
     * @return string 
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * Set priorversionId
     *
     * @param integer $priorversionId
     * @return Uapps
     */
    public function setPriorversionId($priorversionId)
    {
        $this->priorversionId = $priorversionId;
    
        return $this;
    }

    /**
     * Get priorversionId
     *
     * @return integer 
     */
    public function getPriorversionId()
    {
        return $this->priorversionId;
    }

    /**
     * Set active
     *
     * @param boolean $active
     * @return Uapps
     */
    public function setActive($active)
    {
        $this->active = $active;
    
        return $this;
    }

    /**
     * Get active
     *
     * @return boolean 
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * Set developerId
     *
     * @param integer $developerId
     * @return Uapps
     */
    public function setDeveloperId($developerId)
    {
        $this->developerId = $developerId;
    
        return $this;
    }

    /**
     * Get developerId
     *
     * @return integer 
     */
    public function getDeveloperId()
    {
        return $this->developerId;
    }

    /**
     * Add developer
     *
     * @param \Neo\UserBundle\Entity\Udevelopers $developer
     * @return Uapps
     */
    public function addDeveloper(\Neo\UserBundle\Entity\Udevelopers $developer)
    {
        $this->developer[] = $developer;
    
        return $this;
    }

    /**
     * Remove developer
     *
     * @param \Neo\UserBundle\Entity\Udevelopers $developer
     */
    public function removeDeveloper(\Neo\UserBundle\Entity\Udevelopers $developer)
    {
        $this->developer->removeElement($developer);
    }

    /**
     * Get developer
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDeveloper()
    {
        return $this->developer;
    }

    /**
     * Add enterprise
     *
     * @param \Neo\UserBundle\Entity\Uenterprises $enterprise
     * @return Uapps
     */
    public function addEnterprise(\Neo\UserBundle\Entity\Uenterprises $enterprise)
    {
        $this->enterprise[] = $enterprise;
    
        return $this;
    }

    /**
     * Remove enterprise
     *
     * @param \Neo\UserBundle\Entity\Uenterprises $enterprise
     */
    public function removeEnterprise(\Neo\UserBundle\Entity\Uenterprises $enterprise)
    {
        $this->enterprise->removeElement($enterprise);
    }

    /**
     * Get enterprise
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getEnterprise()
    {
        return $this->enterprise;
    }

    /**
     * Add project
     *
     * @param \Neo\UserBundle\Entity\Uprojects $project
     * @return Uapps
     */
    public function addProject(\Neo\UserBundle\Entity\Uprojects $project)
    {
        $this->project[] = $project;
    
        return $this;
    }

    /**
     * Remove project
     *
     * @param \Neo\UserBundle\Entity\Uprojects $project
     */
    public function removeProject(\Neo\UserBundle\Entity\Uprojects $project)
    {
        $this->project->removeElement($project);
    }

    /**
     * Get project
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getProject()
    {
        return $this->project;
    }

    /**
     * Add user
     *
     * @param \Neo\UserBundle\Entity\Uusers $user
     * @return Uapps
     */
    public function addUser(\Neo\UserBundle\Entity\Uusers $user)
    {
        $this->user[] = $user;
    
        return $this;
    }

    /**
     * Remove user
     *
     * @param \Neo\UserBundle\Entity\Uusers $user
     */
    public function removeUser(\Neo\UserBundle\Entity\Uusers $user)
    {
        $this->user->removeElement($user);
    }

    /**
     * Get user
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * Set feemodel
     *
     * @param \Neo\UserBundle\Entity\Uappsfeemodels $feemodel
     * @return Uapps
     */
    public function setFeemodel(\Neo\UserBundle\Entity\Uappsfeemodels $feemodel = null)
    {
        $this->feemodel = $feemodel;
    
        return $this;
    }

    /**
     * Get feemodel
     *
     * @return \Neo\UserBundle\Entity\Uappsfeemodels 
     */
    public function getFeemodel()
    {
        return $this->feemodel;
    }
    public function __tostring()
    {
        return $this->getName();
    }
}