<?php

namespace Neo\UserBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * Uenterprises
 *
 * @ORM\Table(name="UEnterprises")
 * @ORM\Entity
 */
class Uenterprises
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=255, nullable=false)
     */
    private $name;

    /**
     * @var string
     *
     * @ORM\Column(name="nif", type="string", length=255, nullable=true)
     */
    private $nif;

    /**
     * @var string
     *
     * @ORM\Column(name="url", type="string", length=255, nullable=true)
     */
    private $url;

    /**
     * @var string
     *
     * @ORM\Column(name="fiscalName", type="string", length=255, nullable=false)
     */
    private $fiscalname;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="creationDate", type="datetime", nullable=false)
     */
    private $creationdate;

    /**
     * @var boolean
     *
     * @ORM\Column(name="active", type="boolean", nullable=false)
     */
    private $active;

    /**
     * @var string
     *
     * @ORM\Column(name="dbHost", type="string", length=255, nullable=true)
     */
    private $dbhost;

    /**
     * @var string
     *
     * @ORM\Column(name="dbName", type="string", length=255, nullable=true)
     */
    private $dbname;

    /**
     * @var string
     *
     * @ORM\Column(name="dbUser", type="string", length=255, nullable=true)
     */
    private $dbuser;

    /**
     * @var string
     *
     * @ORM\Column(name="dbPassword", type="string", length=255, nullable=true)
     */
    private $dbpassword;

    /**
     * @var string
     *
     * @ORM\Column(name="logoPath", type="string", length=100, nullable=true)
     */
    private $logopath;

    /**
     * @var string
     *
     * @ORM\Column(name="dbVersion", type="string", length=45, nullable=false)
     */
    private $dbversion;

    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @ORM\ManyToMany(targetEntity="Uapps", inversedBy="enterprise")
     * @ORM\JoinTable(name="uappsenterprises",
     *   joinColumns={
     *     @ORM\JoinColumn(name="enterprise_id", referencedColumnName="id")
     *   },
     *   inverseJoinColumns={
     *     @ORM\JoinColumn(name="app_id", referencedColumnName="id")
     *   }
     * )
     */
    private $app;

    /**
     * @var \Doctrine\Common\Collections\Collection
     *
     * @ORM\ManyToMany(targetEntity="Ubusinesstaxonomyicb", inversedBy="enterprise")
     * @ORM\JoinTable(name="uenterpriseclassification",
     *   joinColumns={
     *     @ORM\JoinColumn(name="enterprise_id", referencedColumnName="id")
     *   },
     *   inverseJoinColumns={
     *     @ORM\JoinColumn(name="taxonomy_id", referencedColumnName="id")
     *   }
     * )
     */
    private $taxonomy;

    /**
     * @var \Uaddresses
     *
     * @ORM\ManyToOne(targetEntity="Uaddresses")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="address_id", referencedColumnName="id")
     * })
     */
    private $address;

    /**
     * @var \Uusers
     *
     * @ORM\ManyToOne(targetEntity="User")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="creator_id", referencedColumnName="id")
     * })
     */
    private $creator;

    /**
     * @var \User 
     *
     * @ORM\ManyToMany(targetEntity="User", mappedBy="enterprises")
     */
    private $users;

    /**
     * @var \Uprojects
     *
     * @ORM\ManyToMany(targetEntity="Uprojects", inversedBy="enterprises")
     * @ORM\JoinTable(name="UEnterprisesProjects",
     *      joinColumns={@ORM\JoinColumn(name="project_id", referencedColumnName="id")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="enterprise_id", referencedColumnName="id")}
     * )
     */
    private $projects;


    /**
     * Constructor
     */
    public function __construct()
    {
        $this->app = new \Doctrine\Common\Collections\ArrayCollection();
        $this->taxonomy = new \Doctrine\Common\Collections\ArrayCollection();
    }
    

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set name
     *
     * @param string $name
     * @return Uenterprises
     */
    public function setName($name)
    {
        $this->name = $name;
    
        return $this;
    }

    /**
     * Get name
     *
     * @return string 
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set nif
     *
     * @param string $nif
     * @return Uenterprises
     */
    public function setNif($nif)
    {
        $this->nif = $nif;
    
        return $this;
    }

    /**
     * Get nif
     *
     * @return string 
     */
    public function getNif()
    {
        return $this->nif;
    }

    /**
     * Set url
     *
     * @param string $url
     * @return Uenterprises
     */
    public function setUrl($url)
    {
        $this->url = $url;
    
        return $this;
    }

    /**
     * Get url
     *
     * @return string 
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * Set fiscalname
     *
     * @param string $fiscalname
     * @return Uenterprises
     */
    public function setFiscalname($fiscalname)
    {
        $this->fiscalname = $fiscalname;
    
        return $this;
    }

    /**
     * Get fiscalname
     *
     * @return string 
     */
    public function getFiscalname()
    {
        return $this->fiscalname;
    }

    /**
     * Set creationdate
     *
     * @param \DateTime $creationdate
     * @return Uenterprises
     */
    public function setCreationdate($creationdate)
    {
        $this->creationdate = $creationdate;
    
        return $this;
    }

    /**
     * Get creationdate
     *
     * @return \DateTime 
     */
    public function getCreationdate()
    {
        return $this->creationdate;
    }

    /**
     * Set active
     *
     * @param boolean $active
     * @return Uenterprises
     */
    public function setActive($active)
    {
        $this->active = $active;
    
        return $this;
    }

    /**
     * Get active
     *
     * @return boolean 
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * Set dbhost
     *
     * @param string $dbhost
     * @return Uenterprises
     */
    public function setDbhost($dbhost)
    {
        $this->dbhost = $dbhost;
    
        return $this;
    }

    /**
     * Get dbhost
     *
     * @return string 
     */
    public function getDbhost()
    {
        return $this->dbhost;
    }

    /**
     * Set dbname
     *
     * @param string $dbname
     * @return Uenterprises
     */
    public function setDbname($dbname)
    {
        $this->dbname = $dbname;
    
        return $this;
    }

    /**
     * Get dbname
     *
     * @return string 
     */
    public function getDbname()
    {
        return $this->dbname;
    }

    /**
     * Set dbuser
     *
     * @param string $dbuser
     * @return Uenterprises
     */
    public function setDbuser($dbuser)
    {
        $this->dbuser = $dbuser;
    
        return $this;
    }

    /**
     * Get dbuser
     *
     * @return string 
     */
    public function getDbuser()
    {
        return $this->dbuser;
    }

    /**
     * Set dbpassword
     *
     * @param string $dbpassword
     * @return Uenterprises
     */
    public function setDbpassword($dbpassword)
    {
        $this->dbpassword = $dbpassword;
    
        return $this;
    }

    /**
     * Get dbpassword
     *
     * @return string 
     */
    public function getDbpassword()
    {
        return $this->dbpassword;
    }

    /**
     * Set logopath
     *
     * @param string $logopath
     * @return Uenterprises
     */
    public function setLogopath($logopath)
    {
        $this->logopath = $logopath;
    
        return $this;
    }

    /**
     * Get logopath
     *
     * @return string 
     */
    public function getLogopath()
    {
        return $this->logopath;
    }

    /**
     * Set dbversion
     *
     * @param string $dbversion
     * @return Uenterprises
     */
    public function setDbversion($dbversion)
    {
        $this->dbversion = $dbversion;
    
        return $this;
    }

    /**
     * Get dbversion
     *
     * @return string 
     */
    public function getDbversion()
    {
        return $this->dbversion;
    }


public function setApp($app)
    {
        $this->app = $app;
    
        return $this;
    }
    /**
     * Add app
     *
     * @param \Neo\UserBundle\Entity\Uapps $app
     * @return Uenterprises
     */
    public function addApp(\Neo\UserBundle\Entity\Uapps $app)
    {
        $this->app[] = $app;
    
        return $this;
    }

    /**
     * Remove app
     *
     * @param \Neo\UserBundle\Entity\Uapps $app
     */
    public function removeApp(\Neo\UserBundle\Entity\Uapps $app)
    {
        $this->app->removeElement($app);
    }

    /**
     * Get app
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getApp()
    {
        return $this->app;
    }

    /**
     * Add taxonomy
     *
     * @param \Neo\UserBundle\Entity\Ubusinesstaxonomyicb $taxonomy
     * @return Uenterprises
     */
    public function addTaxonomy(\Neo\UserBundle\Entity\Ubusinesstaxonomyicb $taxonomy)
    {
        $this->taxonomy[] = $taxonomy;
    
        return $this;
    }

    /**
     * Remove taxonomy
     *
     * @param \Neo\UserBundle\Entity\Ubusinesstaxonomyicb $taxonomy
     */
    public function removeTaxonomy(\Neo\UserBundle\Entity\Ubusinesstaxonomyicb $taxonomy)
    {
        $this->taxonomy->removeElement($taxonomy);
    }

    /**
     * Get taxonomy
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getTaxonomy()
    {
        return $this->taxonomy;
    }

    /**
     * Set address
     *
     * @param \Neo\UserBundle\Entity\Uaddresses $address
     * @return Uenterprises
     */
    public function setAddress(\Neo\UserBundle\Entity\Uaddresses $address = null)
    {
        $this->address = $address;
    
        return $this;
    }

    /**
     * Get address
     *
     * @return \Neo\UserBundle\Entity\Uaddresses 
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * Set creator
     *
     * @param \Neo\UserBundle\Entity\User $creator
     * @return Uenterprises
     */
    public function setCreator(\Neo\UserBundle\Entity\User $creator = null)
    {
        $this->creator = $creator;
    
        return $this;
    }

    /**
     * Get creator
     *
     * @return \Neo\UserBundle\Entity\User
     */
    public function getCreator()
    {
        return $this->creator;
    }

    public function __toString()
    {
        return $this->getName();
    }
}